// FROG_Coord.cpp: interface for the FROG_Coord functions.
//////////////////////////////////////////////////////////////////////

#include "FROG_Coord.h"

namespace FROG_COORD{

	float EtaToTheta(float Eta){return 2*atan(exp(-Eta));}

	void  PhysicalToCartesian(float P, float Eta, float Phi, float& X, float& Y  , float& Z){		
		float Theta = EtaToTheta(Eta);

		X = P*sin(Theta)*cos(Phi);
		Y = P*sin(Theta)*sin(Phi);
		Z = P*cos(Theta);
	}

	void  CartesianToPhysical(float X, float Y  , float Z  , float& P, float& Eta, float& Phi){
		P           = sqrt(X*X+Y*Y+Z*Z);
		Phi         = atan2(Y,X);
		float Theta = atan2(sqrt(X*X+Y*Y),Z);
		Eta         = -log(tan(Theta/2));
	}


	float GetPt(float P, float Eta){
		return P*sin(EtaToTheta(Eta));
	}


}

