#ifndef _FROG_ELEMENT_EVENT_NUCLINT_H__
#define _FROG_ELEMENT_EVENT_NUCLINT_H__

#include "FROG_Element_Base.h"
#include "FROG_Objects_Extended.h"

class FROG_Element_Event_NuclInt :  public FROG_Element_Base {
public :	
	float PosX;    float PosY;    float PosZ; float likelihood;
        FROG_Objects_Extended*  frogObjects_;         
        unsigned int nameId_;

	virtual bool isCompactible(){ return true; }

	static unsigned int sizeOf(){ return FROG_Element_Base::sizeOf() + 4*sizeof(float);}

	FROG_Element_Event_NuclInt(float posX,    float posY,    float posZ, float likeli):
	FROG_Element_Base(C_RECO_NUCL),	
	PosX(posX),	PosY(posY),	PosZ(posZ),	likelihood(likeli)
	{    
		size_ = sizeOf();
	}

	FROG_Element_Event_NuclInt(FILE* pFile) : FROG_Element_Base(C_RECO_NUCL)
	{   
		size_ = sizeOf();
		fread(&PosX             ,sizeof(PosX)            ,1,pFile);
		fread(&PosY             ,sizeof(PosY)            ,1,pFile);
		fread(&PosZ             ,sizeof(PosZ)            ,1,pFile);
		fread(&likelihood       ,sizeof(likelihood)      ,1,pFile);
	}

	virtual void write () {
		size_ = sizeOf();
		data_ = new unsigned char[size_-6];
		data_ = FillBuffer( data_, &PosX,				sizeof(PosX));
		data_ = FillBuffer( data_, &PosY,				sizeof(PosY));
		data_ = FillBuffer( data_, &PosZ,				sizeof(PosZ));
		data_ = FillBuffer( data_, &likelihood,				sizeof(likelihood));
		data_ = (unsigned char*)((unsigned long)data_ - (size_-6) );		
	}

	#ifdef FROG_OPENGL
	virtual void display(bool UseDisplayList=true, float* color=NULL){
		// first Init Colors & Style!
		init(NULL);
		glColor4fv (style_->color_);

		if(Start_Display(UseDisplayList)){
			glLoadName( nameId_ );			

			if(style_->marker_>0){
					glBindTexture(GL_TEXTURE_2D,frogObjects_->getMarker(style_->marker_));
					glEnable(GL_TEXTURE_2D);
					glTexEnvf( GL_POINT_SPRITE_ARB, GL_COORD_REPLACE_ARB, GL_TRUE );
					glEnable( GL_POINT_SPRITE_ARB );
			}

			glPointSize (style_->markerSize_);
			glBegin (GL_POINTS);
			glVertex3f(PosX, PosY, PosZ);
			glEnd();

			if(style_->marker_>0){
					glDisable( GL_POINT_SPRITE_ARB );
					glDisable(GL_TEXTURE_2D);
					glBindTexture(GL_TEXTURE_2D,0);
			}

			End_Display(UseDisplayList);
		}
     }
	#endif

    virtual void init(void* frogObjects){
		if(frogObjects!=NULL){
			frogObjects_ = (FROG_Objects_Extended*) frogObjects;
			nameId_      = frogObjects_->frogEvent_->name_map.size();
			frogObjects_->frogEvent_->name_map.push_back(this);			
		}else if(frogObjects==NULL && frogObjects_ != NULL){
			if(mother_ != NULL && mother_->style_ !=NULL){ style_ = mother_->style_;
			}else{										   style_ = new FROG_Objects_Style();  }
        }
	}

};
#endif
