#ifndef _FROG_ELEMENT_GEOM_TRACKERMOD_H__
#define _FROG_ELEMENT_GEOM_TRACKERMOD_H__

#include "FROG_Element_Base_With_DetId.h"
#include "FROG_Objects.h"
#include "FROG_Primitives.h"

class FROG_Element_Geom_TrackerMod : public FROG_Element_Base_With_DetId {
public :
	float TrapezoidalParam;
	float PosX;    float PosY;    float PosZ;
	float WidthX;  float WidthY;  float WidthZ;
	float LengthX; float LengthY; float LengthZ;
	float ThickX;  float ThickY;  float ThickZ;
	FROG_Objects*  frogObjects_;

	virtual bool isCompactible(){ return true; }

	static unsigned int sizeOf(){ return FROG_Element_Base_With_DetId::sizeOf() + 13*sizeof(float);}

	FROG_Element_Geom_TrackerMod(unsigned int detId, float trapezoidalParam,
	float posX,    float posY,    float posZ,
	float widthX,  float widthY,  float widthZ,
	float lengthX, float lengthY, float lengthZ,
	float thickX,  float thickY,  float thickZ,
	unsigned short chunkType=C_TRACKER_MOD) : 
	FROG_Element_Base_With_DetId(chunkType,detId),
	TrapezoidalParam(trapezoidalParam),
	PosX(posX), PosY(posY), PosZ(posZ),
	WidthX(widthX), WidthY(widthY), WidthZ(widthZ),
	LengthX(lengthX), LengthY(lengthY), LengthZ(lengthZ),
	ThickX(thickX),  ThickY(thickY), ThickZ(thickZ)
	{   
		size_ = sizeOf();		
	}

	FROG_Element_Geom_TrackerMod(FILE* pFile, unsigned short chunkType=C_TRACKER_MOD) : FROG_Element_Base_With_DetId(chunkType)
	{   
		size_ = sizeOf();
		fread(&detId_           ,sizeof(detId_)          ,1,pFile);
		fread(&TrapezoidalParam ,sizeof(TrapezoidalParam),1,pFile);
		fread(&PosX             ,sizeof(PosX)            ,1,pFile);
		fread(&PosY             ,sizeof(PosY)            ,1,pFile);
		fread(&PosZ             ,sizeof(PosZ)            ,1,pFile);
		fread(&WidthX           ,sizeof(WidthX)          ,1,pFile);
		fread(&WidthY           ,sizeof(WidthY)          ,1,pFile);
		fread(&WidthZ           ,sizeof(WidthZ)          ,1,pFile);
		fread(&LengthX          ,sizeof(LengthX)         ,1,pFile);
		fread(&LengthY          ,sizeof(LengthY)         ,1,pFile);
		fread(&LengthZ          ,sizeof(LengthZ)         ,1,pFile);
		fread(&ThickX           ,sizeof(ThickX)          ,1,pFile);
		fread(&ThickY           ,sizeof(ThickY)          ,1,pFile);
		fread(&ThickZ           ,sizeof(ThickZ)          ,1,pFile);
	}

	virtual void write () {
		size_ = sizeOf();
		data_ = new unsigned char[size_-6];
		data_ = FillBuffer( data_, &detId_,				sizeof(detId_));
		data_ = FillBuffer( data_, &TrapezoidalParam,	sizeof(TrapezoidalParam));
		data_ = FillBuffer( data_, &PosX,				sizeof(PosX));
		data_ = FillBuffer( data_, &PosY,				sizeof(PosY));
		data_ = FillBuffer( data_, &PosZ,				sizeof(PosZ));
		data_ = FillBuffer( data_, &WidthX,				sizeof(WidthX));
		data_ = FillBuffer( data_, &WidthY,				sizeof(WidthY));
		data_ = FillBuffer( data_, &WidthZ,				sizeof(WidthZ));
		data_ = FillBuffer( data_, &LengthX,			sizeof(LengthX));
		data_ = FillBuffer( data_, &LengthY,			sizeof(LengthY));
		data_ = FillBuffer( data_, &LengthZ,			sizeof(LengthZ));
		data_ = FillBuffer( data_, &ThickX,				sizeof(ThickX));
		data_ = FillBuffer( data_, &ThickY,				sizeof(ThickY));
		data_ = FillBuffer( data_, &ThickZ,				sizeof(ThickZ));
		data_ = (unsigned char*)((unsigned long)data_ - (size_-6) );		
	}

	#ifdef FROG_OPENGL
	virtual void display(bool UseDisplayList=true, float* color=NULL){				

		// first Init Colors & Style!
		init(NULL);
		if(color){glColor4fv(color);}else{glColor4fv(style_->color_);}

		if(Start_Display(UseDisplayList)){
			glLoadName( detId_ );

			double TP = TrapezoidalParam;		

		DrawCube(PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ,
				 PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ,				 
				 PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ,
				 PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ,
				 PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ,
				 PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ,
				 PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ,
				 PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);

/*			glBegin (GL_QUADS); 		
				glVertex3f (PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ);	//+++
				glVertex3f (PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ);	//-++
				glVertex3f (PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ);	//--+
				glVertex3f (PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ);	//+-+
							
				glVertex3f (PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ);	//++-
				glVertex3f (PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ);	//+--
				glVertex3f (PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ);	//---
				glVertex3f (PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);	//-+-
				
				glVertex3f (PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ);	//+++ 
				glVertex3f (PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ);	//++-
				glVertex3f (PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);	//-+- 
				glVertex3f (PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ);	//-++ 			

				glVertex3f (PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ);	//+-+ 
				glVertex3f (PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ);	//--+
				glVertex3f (PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ);	//---
				glVertex3f (PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ);	//+--
				
				glVertex3f (PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ);	//+++
				glVertex3f (PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ);	//+-+
				glVertex3f (PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ);	//+--
				glVertex3f (PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ);	//++-
				
				glVertex3f (PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ);	//-++
				glVertex3f (PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);	//-+-			
				glVertex3f (PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ);	//---
				glVertex3f (PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ);	//--+			
			glEnd();
*/

			End_Display(UseDisplayList);
		}
	}

	void displayLines(bool UseDisplayList=true, float* color=NULL){		
		// first Init Colors & Style!
		init(NULL);
		
		glLoadName( detId_ );
		if(color){glColor4fv(color);}else{glColor4fv(style_->color_);}
		
		double TP = TrapezoidalParam;		
		glBegin (GL_LINES); 		
			glVertex3f (PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ);	//+++
			glVertex3f (PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ);	//-++
			glVertex3f (PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ);	//--+
			glVertex3f (PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ);	//+-+
						
			glVertex3f (PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ);	//++-
			glVertex3f (PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ);	//+--
			glVertex3f (PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ);	//---
			glVertex3f (PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);	//-+-
			
			glVertex3f (PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ);	//+++ 
			glVertex3f (PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ);	//++-
			glVertex3f (PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);	//-+- 
			glVertex3f (PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ);	//-++ 			

			glVertex3f (PosX+WidthX*TP +LengthX-ThickX,PosY+WidthY*TP+LengthY-ThickY,PosZ+WidthZ*TP+LengthZ-ThickZ);	//++-
			glVertex3f (PosX-WidthX*TP +LengthX-ThickX,PosY-WidthY*TP+LengthY-ThickY,PosZ-WidthZ*TP+LengthZ-ThickZ);	//-+-
			glVertex3f (PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ);	//---
			glVertex3f (PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ);	//+--
			
			glVertex3f (PosX+WidthX*TP +LengthX+ThickX,PosY+WidthY*TP+LengthY+ThickY,PosZ+WidthZ*TP+LengthZ+ThickZ);	//+++
			glVertex3f (PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ);	//+-+
			glVertex3f (PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ);	//--+
			glVertex3f (PosX-WidthX*TP +LengthX+ThickX,PosY-WidthY*TP+LengthY+ThickY,PosZ-WidthZ*TP+LengthZ+ThickZ);	//-++
			
			glVertex3f (PosX+WidthX    -LengthX+ThickX,PosY+WidthY   -LengthY+ThickY,PosZ+WidthZ   -LengthZ+ThickZ);	//+-+
			glVertex3f (PosX+WidthX    -LengthX-ThickX,PosY+WidthY   -LengthY-ThickY,PosZ+WidthZ   -LengthZ-ThickZ);	//+--
			glVertex3f (PosX-WidthX    -LengthX-ThickX,PosY-WidthY   -LengthY-ThickY,PosZ-WidthZ   -LengthZ-ThickZ);	//---
			glVertex3f (PosX-WidthX    -LengthX+ThickX,PosY-WidthY   -LengthY+ThickY,PosZ-WidthZ   -LengthZ+ThickZ);	//--+			
		glEnd();
	}
	#endif

	virtual void init(void* frogObjects){
		if(frogObjects!=NULL){
			frogObjects_ = (FROG_Objects*) frogObjects;			
		}else if(frogObjects==NULL && frogObjects_ != NULL){
			if(mother_ != NULL && mother_->style_ !=NULL){		style_ = mother_->style_;
			}else{												style_ = new FROG_Objects_Style();	}	
		}
	}

	virtual double getPosX(){	return PosX;	}
	virtual double getPosY(){	return PosY;	}
	virtual double getPosZ(){	return PosZ;	}
};
#endif

