#ifndef _FROG_ELEMENT_PRIMITIVE_CUSTOMCUBE_H__
#define _FROG_ELEMENT_PRIMITIVE_CUSTOMCUBE_H__

#include "FROG_Primitives.h"
#include "FROG_Element_Base.h"

class FROG_Element_Primitive_CustomCube :  public FROG_Element_Base_With_DetId {
public :	
	float P1X;    float P1Y;  float P1Z;
	float P2X;    float P2Y;  float P2Z;	
	float P3X;    float P3Y;  float P3Z;
	float P4X;    float P4Y;  float P4Z;	
	float P5X;    float P5Y;  float P5Z;
	float P6X;    float P6Y;  float P6Z;	
	float P7X;    float P7Y;  float P7Z;
	float P8X;    float P8Y;  float P8Z;	
	FROG_Objects*  frogObjects_;

	virtual bool isCompactible(){ return true; }

	static unsigned int sizeOf(){ return FROG_Element_Base_With_DetId::sizeOf() + 24*sizeof(float); }

	FROG_Element_Primitive_CustomCube(
	unsigned int detId,			  
	float p1X,    float p1Y,    float p1Z,
	float p2X,	  float p2Y,    float p2Z,
	float p3X,    float p3Y,    float p3Z,
	float p4X,	  float p4Y,    float p4Z,
	float p5X,    float p5Y,    float p5Z,
	float p6X,	  float p6Y,    float p6Z,
	float p7X,    float p7Y,    float p7Z,
	float p8X,	  float p8Y,    float p8Z	):
	FROG_Element_Base_With_DetId(C_PRIMITIVE_CUSTOM_CUBE,detId),		
	P1X(p1X),			P1Y(p1Y),			P1Z(p1Z),
	P2X(p2X),			P2Y(p2Y),			P2Z(p2Z),
	P3X(p3X),			P3Y(p3Y),			P3Z(p3Z),
	P4X(p4X),			P4Y(p4Y),			P4Z(p4Z),
	P5X(p5X),			P5Y(p5Y),			P5Z(p5Z),
	P6X(p6X),			P6Y(p6Y),			P6Z(p6Z),
	P7X(p7X),			P7Y(p7Y),			P7Z(p7Z),
	P8X(p8X),			P8Y(p8Y),			P8Z(p8Z)
	{    
		size_ = sizeOf();
	}

	FROG_Element_Primitive_CustomCube(FILE* pFile) : FROG_Element_Base_With_DetId(C_PRIMITIVE_CUSTOM_CUBE)
	{   
		size_ = sizeOf();
		fread(&detId_           ,sizeof(detId_)			,1,pFile);				
		fread(&P1X              ,sizeof(P1X)            ,1,pFile);
		fread(&P1Y              ,sizeof(P1Y)            ,1,pFile);
		fread(&P1Z              ,sizeof(P1Z)            ,1,pFile);
		fread(&P2X              ,sizeof(P2X)            ,1,pFile);
		fread(&P2Y              ,sizeof(P2Y)            ,1,pFile);
		fread(&P2Z              ,sizeof(P2Z)            ,1,pFile);
		fread(&P3X              ,sizeof(P3X)            ,1,pFile);
		fread(&P3Y              ,sizeof(P3Y)            ,1,pFile);
		fread(&P3Z              ,sizeof(P3Z)            ,1,pFile);
		fread(&P4X              ,sizeof(P4X)            ,1,pFile);
		fread(&P4Y              ,sizeof(P4Y)            ,1,pFile);
		fread(&P4Z              ,sizeof(P4Z)            ,1,pFile);
		fread(&P5X              ,sizeof(P5X)            ,1,pFile);
		fread(&P5Y              ,sizeof(P5Y)            ,1,pFile);
		fread(&P5Z              ,sizeof(P5Z)            ,1,pFile);
		fread(&P6X              ,sizeof(P6X)            ,1,pFile);
		fread(&P6Y              ,sizeof(P6Y)            ,1,pFile);
		fread(&P6Z              ,sizeof(P6Z)            ,1,pFile);
		fread(&P7X              ,sizeof(P7X)            ,1,pFile);
		fread(&P7Y              ,sizeof(P7Y)            ,1,pFile);
		fread(&P7Z              ,sizeof(P7Z)            ,1,pFile);
		fread(&P8X              ,sizeof(P8X)            ,1,pFile);
		fread(&P8Y              ,sizeof(P8Y)            ,1,pFile);
		fread(&P8Z              ,sizeof(P8Z)            ,1,pFile);
	}

	virtual void write () {
		size_ = sizeOf();
		data_ = new unsigned char[size_-6];
		data_ = FillBuffer(	data_, &detId_,				sizeof(detId_));
		data_ = FillBuffer( data_, &P1X,				sizeof(P1X));
		data_ = FillBuffer( data_, &P1Y,				sizeof(P1Y));
		data_ = FillBuffer( data_, &P1Z,				sizeof(P1Z));
		data_ = FillBuffer( data_, &P2X,				sizeof(P2X));
		data_ = FillBuffer( data_, &P2Y,				sizeof(P2Y));
		data_ = FillBuffer( data_, &P2Z,				sizeof(P2Z));
		data_ = FillBuffer( data_, &P3X,				sizeof(P3X));
		data_ = FillBuffer( data_, &P3Y,				sizeof(P3Y));
		data_ = FillBuffer( data_, &P3Z,				sizeof(P3Z));
		data_ = FillBuffer( data_, &P4X,				sizeof(P4X));
		data_ = FillBuffer( data_, &P4Y,				sizeof(P4Y));
		data_ = FillBuffer( data_, &P4Z,				sizeof(P4Z));
		data_ = FillBuffer( data_, &P5X,				sizeof(P5X));
		data_ = FillBuffer( data_, &P5Y,				sizeof(P5Y));
		data_ = FillBuffer( data_, &P5Z,				sizeof(P5Z));
		data_ = FillBuffer( data_, &P6X,				sizeof(P6X));
		data_ = FillBuffer( data_, &P6Y,				sizeof(P6Y));
		data_ = FillBuffer( data_, &P6Z,				sizeof(P6Z));
		data_ = FillBuffer( data_, &P7X,				sizeof(P7X));
		data_ = FillBuffer( data_, &P7Y,				sizeof(P7Y));
		data_ = FillBuffer( data_, &P7Z,				sizeof(P7Z));
		data_ = FillBuffer( data_, &P8X,				sizeof(P8X));
		data_ = FillBuffer( data_, &P8Y,				sizeof(P8Y));
		data_ = FillBuffer( data_, &P8Z,				sizeof(P8Z));
		data_ = (unsigned char*)((unsigned long)data_ - (size_-6) );		
	}

	#ifdef FROG_OPENGL
	virtual void display(bool UseDisplayList=true, float* color=NULL){
		// first Init Colors & Style!
		init(NULL);

		glLineWidth(style_->thickness_);
        if(color){glColor4fv(color);}else{glColor4fv(style_->color_);}
		glLoadName( detId_ );

		DrawCube(P1X, P1Y, P1Z,
				 P2X, P2Y, P2Z,
				 P3X, P3Y, P3Z,
				 P4X, P4Y, P4Z,
				 P5X, P5Y, P5Z,
				 P6X, P6Y, P6Z,
				 P7X, P7Y, P7Z,
				 P8X, P8Y, P8Z);
/*
		glBegin (GL_QUADS); 			
			glVertex3f (P1X,P1Y,P1Z);		//+++			
			glVertex3f (P4X,P4Y,P4Z);		//+-+
			glVertex3f (P3X,P3Y,P3Z);		//--+
			glVertex3f (P2X,P2Y,P2Z);		//-++			
			
			glVertex3f (P5X,P5Y,P5Z);		//++-
			glVertex3f (P6X,P6Y,P6Z);		//-+- 
			glVertex3f (P7X,P7Y,P7Z);		//---
			glVertex3f (P8X,P8Y,P8Z);		//+--

			glVertex3f (P1X,P1Y,P1Z);		//+++ 
			glVertex3f (P2X,P2Y,P2Z);		//-++ 
			glVertex3f (P6X,P6Y,P6Z);		//-+- 
			glVertex3f (P5X,P5Y,P5Z);		//++-

			glVertex3f (P4X,P4Y,P4Z);		//+-+ 			
			glVertex3f (P8X,P8Y,P8Z);		//+--
			glVertex3f (P7X,P7Y,P7Z);		//---
			glVertex3f (P3X,P3Y,P3Z);		//--+

			glVertex3f (P1X,P1Y,P1Z);		//+++
			glVertex3f (P5X,P5Y,P5Z);		//++-
			glVertex3f (P8X,P8Y,P8Z); 		//+--
			glVertex3f (P4X,P4Y,P4Z);		//+-+

			glVertex3f (P2X,P2Y,P2Z);		//-++
			glVertex3f (P3X,P3Y,P3Z);		//--+
			glVertex3f (P7X,P7Y,P7Z);		//---
			glVertex3f (P6X,P6Y,P6Z);		//-+-			
		glEnd(); 		
*/
	}
	#endif

	virtual void init(void* frogObjects){
		if(frogObjects!=NULL){
			frogObjects_ = (FROG_Objects*) frogObjects;			
		}else if(frogObjects==NULL && frogObjects_ != NULL){
			if(mother_ != NULL && mother_->style_ !=NULL){		style_ = new FROG_Objects_Style(mother_->style_);
			}else{												style_ = new FROG_Objects_Style();	}	

			frogObjects_->frogCard_->GetColor( style_->color_     ,"Id_%i_Color"		,detId_);
			frogObjects_->frogCard_->GetFloat(&style_->thickness_ ,"Id_%i_Thickness"	,detId_);
		}
	}
};
#endif
