#ifndef _FROG_ELEMENT_PRIMITIVE_CUSTOMSURFACE_H__
#define _FROG_ELEMENT_PRIMITIVE_CUSTOMSURFACE_H__

#include "FROG_Element_Base.h"

class FROG_Element_Primitive_CustomSurface : public FROG_Element_Base_With_DetId {
public :	
	float P1X;    float P1Y;  float P1Z;
	float P2X;    float P2Y;  float P2Z;	
	float P3X;    float P3Y;  float P3Z;
	float P4X;    float P4Y;  float P4Z;	
	FROG_Objects*  frogObjects_;

	virtual bool isCompactible(){ return true; }

	static unsigned int sizeOf(){ return FROG_Element_Base_With_DetId::sizeOf() + 12*sizeof(float); }

	FROG_Element_Primitive_CustomSurface(
	unsigned int detId,			  
	float p1X,    float p1Y,    float p1Z,
	float p2X,	  float p2Y,    float p2Z,
	float p3X,    float p3Y,    float p3Z,
	float p4X,	  float p4Y,    float p4Z):
	FROG_Element_Base_With_DetId(C_PRIMITIVE_CUSTOM_SURFACE,detId),
	P1X(p1X),			P1Y(p1Y),			P1Z(p1Z),
	P2X(p2X),			P2Y(p2Y),			P2Z(p2Z),
	P3X(p3X),			P3Y(p3Y),			P3Z(p3Z),
	P4X(p4X),			P4Y(p4Y),			P4Z(p4Z)	
	{    
		size_ = sizeOf();
	}

	FROG_Element_Primitive_CustomSurface(FILE* pFile) : FROG_Element_Base_With_DetId(C_PRIMITIVE_CUSTOM_SURFACE)
	{   
		size_ = sizeOf();
		fread(&detId_           ,sizeof(detId_)			,1,pFile);				
		fread(&P1X              ,sizeof(P1X)            ,1,pFile);
		fread(&P1Y              ,sizeof(P1Y)            ,1,pFile);
		fread(&P1Z              ,sizeof(P1Z)            ,1,pFile);
		fread(&P2X              ,sizeof(P2X)            ,1,pFile);
		fread(&P2Y              ,sizeof(P2Y)            ,1,pFile);
		fread(&P2Z              ,sizeof(P2Z)            ,1,pFile);
		fread(&P3X              ,sizeof(P3X)            ,1,pFile);
		fread(&P3Y              ,sizeof(P3Y)            ,1,pFile);
		fread(&P3Z              ,sizeof(P3Z)            ,1,pFile);
		fread(&P4X              ,sizeof(P4X)            ,1,pFile);
		fread(&P4Y              ,sizeof(P4Y)            ,1,pFile);
		fread(&P4Z              ,sizeof(P4Z)            ,1,pFile);
	}

	virtual void write () {
		size_ = sizeOf();
		data_ = new unsigned char[size_-6];
		data_ = FillBuffer(	data_, &detId_,				sizeof(detId_));
		data_ = FillBuffer( data_, &P1X,				sizeof(P1X));
		data_ = FillBuffer( data_, &P1Y,				sizeof(P1Y));
		data_ = FillBuffer( data_, &P1Z,				sizeof(P1Z));
		data_ = FillBuffer( data_, &P2X,				sizeof(P2X));
		data_ = FillBuffer( data_, &P2Y,				sizeof(P2Y));
		data_ = FillBuffer( data_, &P2Z,				sizeof(P2Z));
		data_ = FillBuffer( data_, &P3X,				sizeof(P3X));
		data_ = FillBuffer( data_, &P3Y,				sizeof(P3Y));
		data_ = FillBuffer( data_, &P3Z,				sizeof(P3Z));
		data_ = FillBuffer( data_, &P4X,				sizeof(P4X));
		data_ = FillBuffer( data_, &P4Y,				sizeof(P4Y));
		data_ = FillBuffer( data_, &P4Z,				sizeof(P4Z));
		data_ = (unsigned char*)((unsigned long)data_ - (size_-6) );		
	}

	#ifdef FROG_OPENGL
	virtual void display(bool UseDisplayList=true, float* color=NULL){
		// first Init Colors & Style!
		init(NULL);

		glLineWidth(style_->thickness_);
        if(color){glColor4fv(color);}else{glColor4fv(style_->color_);}
		glLoadName( detId_ );

		glBegin (GL_QUADS); 			
			glVertex3f (P1X, P1Y, P1Z);	// FIRST FACE
			glVertex3f (P2X, P2Y, P2Z);
			glVertex3f (P3X, P3Y, P3Z);
			glVertex3f (P4X, P4Y, P4Z);

			glVertex3f (P1X, P1Y, P1Z);	// SECOND FACE
			glVertex3f (P4X, P4Y, P4Z);
			glVertex3f (P3X, P3Y, P3Z);
			glVertex3f (P2X, P2Y, P2Z);			
		glEnd(); 		
	}
	#endif

	virtual void init(void* frogObjects){
		if(frogObjects!=NULL){
			frogObjects_ = (FROG_Objects*) frogObjects;			
		}else if(frogObjects==NULL && frogObjects_ != NULL){
			if(mother_ != NULL && mother_->style_ !=NULL){		style_ = new FROG_Objects_Style(mother_->style_);
			}else{												style_ = new FROG_Objects_Style();	}	

			frogObjects_->frogCard_->GetColor( style_->color_     ,"Id_%i_Color"		,detId_);
			frogObjects_->frogCard_->GetFloat(&style_->thickness_ ,"Id_%i_Thickness"	,detId_);
		}
	}
};
#endif
