// FROG_Fonts.h: interface for the FROG_Fonts class.
//////////////////////////////////////////////////////////////////////

#ifndef _FROG_FONTS_H__
#define _FROG_FONTS_H__

#include <map>
#include "FROG_Font.h"


class FROG_Fonts{
private : 
	std::map<unsigned char,FROG_Font*> fonts;
public : 
	FROG_Font* Font_Fixed_8_by_13;
	FROG_Font* Font_Fixed_9_by_15;
	FROG_Font* Font_Helvetica_10;
	FROG_Font* Font_Helvetica_12;
	FROG_Font* Font_Helvetica_18;
	FROG_Font* Font_Times_Roman_10;
	FROG_Font* Font_Times_Roman_24;

public :
	FROG_Fonts(){
		Font_Fixed_8_by_13		= new FROG_Font(GLUT_BITMAP_8_BY_13       , 13);
		Font_Fixed_9_by_15		= new FROG_Font(GLUT_BITMAP_9_BY_15       , 15);
		Font_Helvetica_10		= new FROG_Font(GLUT_BITMAP_HELVETICA_10  , 10);
		Font_Helvetica_12		= new FROG_Font(GLUT_BITMAP_HELVETICA_12  , 12);
		Font_Helvetica_18		= new FROG_Font(GLUT_BITMAP_HELVETICA_18  , 18);
		Font_Times_Roman_10		= new FROG_Font(GLUT_BITMAP_TIMES_ROMAN_10, 10);
		Font_Times_Roman_24		= new FROG_Font(GLUT_BITMAP_TIMES_ROMAN_24, 24);

		fonts[13] = Font_Fixed_8_by_13;
		fonts[15] = Font_Fixed_9_by_15;
		fonts[11] = Font_Helvetica_10;
		fonts[12] = Font_Helvetica_12;
		fonts[18] = Font_Helvetica_18;
		fonts[10] = Font_Times_Roman_10;
		fonts[24] = Font_Times_Roman_24;
	}

	FROG_Font* Font(unsigned char size)	{return fonts[size];}
	FROG_Font* Font_Biggest()			{return fonts[24];}
	FROG_Font* Font_Smallest()			{return fonts[10];}
/*	FROG_Font* Font_Fixed_8_by_13()		{return fonts[13];}
	FROG_Font* Font_Fixed_9_by_15()		{return fonts[15];}
	FROG_Font* Font_Helvetica_10()		{return fonts[10];}
	FROG_Font* Font_Helvetica_12()		{return fonts[12];}
	FROG_Font* Font_Helvetica_18()		{return fonts[18];}
	FROG_Font* Font_Times_Roman_10()	{return fonts[11];}
	FROG_Font* Font_Times_Roman_24()	{return fonts[24];}*/
};


#endif


