
#include "FROG_Light.h"

void FROG_Light::SwitchLight_On(float X, float Y, float Z){
	#ifdef FROG_LIGHTING
		glEnable(GL_LIGHTING);
		glColorMaterial ( GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE ) ;
		glEnable ( GL_COLOR_MATERIAL ) ;

		glEnable(GL_LIGHT0); 		

		float local_pos[] = { X, Y, Z, 1 };
		glLightfv(GL_LIGHT0, GL_POSITION, local_pos);

		float local_amb[] = { 0.5f, 0.5f, 0.5f, 1.0f };
		glLightfv(GL_LIGHT0, GL_AMBIENT_AND_DIFFUSE, local_amb);

		float global_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
	#endif
}

void FROG_Light::SwitchLight_Off(){
	#ifdef FROG_LIGHTING
		glDisable(GL_LIGHT0); 		
		glDisable(GL_LIGHTING);
		glDisable(GL_COLOR_MATERIAL ) ;
	#endif
}

void FROG_Light::SwitchLight_NoNormal(){
	#ifdef FROG_LIGHTING
		float global_ambient[] = { 1.0f, 1.0f, 1.0f, 1.0f };
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
	#endif
}

void FROG_Light::SwitchLight_Normal(){
	#ifdef FROG_LIGHTING
		float global_ambient[] = { 0.5f, 0.5f, 0.5f, 1.0f };
		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
	#endif
}


