
#ifndef _FROG_NET_TOOLS_H__
#define _FROG_NET_TOOLS_H__

#include <stdio.h>
#include <iostream>

#include "FROG_Net.h"
#include "FROG_ZLib.h"

bool GetPathFromURL(char* dest, char* inputFile, unsigned int sizeMax)
{
	std::string result((char*)inputFile);
	bool toReturn = false;

	// check if inputVisFile contains http:// or ftp://
	string::size_type loc  = result.find( "http://", 0 );
	string::size_type loc2 = result.find( "ftp://", 0 );		   

	if( loc != string::npos || loc2 != string::npos) {
		 int End = result.rfind('/');			 

		 string local     = result.substr(End+1,result.size());
		 string localPath = string("Files/") + local;		 
		 result           = localPath;		 
		 toReturn         = true;
	}

	if(result.size()>sizeMax){
		printf("GetPathFromURL : sizeMax is smaller than the actual string size\n");
	}else{
		strcpy(dest,result.c_str());
	}

	return toReturn;		  
}

bool IsExpectedFileSize(char* fileName){
	FILE* FileExist = fopen(fileName,"rb");
	if(!FileExist)return false;

	fseek(FileExist,0,SEEK_SET);
	unsigned short chunk_type     = 0;
	unsigned int   chunk_size     = 0;
	fread(&chunk_type, 1, sizeof(unsigned short), FileExist);
	fread(&chunk_size, 1, sizeof(unsigned int)  , FileExist);
	fseek(FileExist,0,SEEK_END);
	if( (long int)(chunk_size) > ftell(FileExist) ){
		fclose(FileExist);
		return false;
	}	
	fclose(FileExist);
	return true;
}

void* DownLoadFile(void* inputFile){

	char* localPath = new char[2048];
	bool IsURL = GetPathFromURL(localPath,(char*)inputFile,2048);

	if(IsURL) {
		char local[2048];
		strcpy(local,localPath+6);

		//Check if unzipped file (or file, in case of not .gz extension) exist
//		if(!FROG_ZLIB_IsUnZippedFileExist(localPath) || (FROG_ZLIB_IsUnZippedFileExist(localPath) && !CheckFileSize(FileExist)) ){
		if(!FROG_ZLIB_IsUnZippedFileExist(localPath) || (!FROG_ZLIB_IsGZip(localPath) && !IsExpectedFileSize(localPath)) ){
			printf("Loading %s from %s\n",local,(char*)inputFile);
			printf("This can take few seconds\n");
			FROG_Net net;
			net.connect((char*)inputFile);
			net.write(localPath);
			net.close();
		}
	}

	if(FROG_ZLIB_IsGZip(localPath)){
		FROG_ZLIB_Inflate(localPath);
	}

	if(!IsExpectedFileSize(localPath) ){
		printf("The downloaded File is corrupted\nAre you sure of the quality of the transfert?\n");
		printf("- The .vis file doesn't exist yet\n");
		printf("- Bug During the Download! : Clean up the directory File/ of all the .vis file\n");
		printf("- Strong firewall : Download the file by yourself and copy it in the File/ repository\n");
		printf("- NoIdea : Go on the FROG website http://projects.hepforge.org/frog/\n");
		printf("  Download the latest FROG version and/or ask help on the mailing list\n");
		//exit(0);
	}


	return localPath;		  
}


#ifdef linux
#elif macos
#else
DWORD WINAPI WinDownLoadFile( LPVOID lpParam ) {
	// interface for windows
    char* fileName_ = (char*)lpParam;
	DownLoadFile(fileName_);
	return 0;
}
#endif

#endif


