// FROG_View.h: interface for the FROG_View class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _FROG_VIEW_3D_H__
#define _FROG_VIEW_3D_H__

#include "FROG_View.h"

class FROG_View_3D : public FROG_View{
public : 
	bool	shouldRotate_;	
	float	dphi_;

public :
	FROG_View_3D(char* Name, FROG_Objects_Extended* frogObjects) : FROG_View(Name, frogObjects){
		Type_           = 3;
		shouldRotate_	= true;										  
		dphi_			= 0.005f;	

		if(frogObjects_ && frogObjects_->frogCard_){
			shouldRotate_ = frogObjects_->frogCard_->GetBool(shouldRotate_, "%s_Animate_Rotate", Name_);			
			frogObjects_->frogCard_->GetFloat(&dphi_		, "%s_Animate_dphi"  , Name_);						
		}		
	}
	virtual bool Is2D(){return false;}
	virtual bool Is3D(){return true;}

	virtual void ProjectionMatrix(){
		gluPerspective (45.0, (GLfloat)vw_/(GLfloat)vh_, 0.1, 5000.0);
		//gluPerspective (45.0, (GLfloat)vw_/(GLfloat)vh_, 150, 5000.0);
	}

	virtual void Display_Begin(){
		if(shouldRotate_) cam_->phi += dphi_;

		glViewport (vx_, vy_, (GLsizei)vw_, (GLsizei)vh_);

		glMatrixMode (GL_PROJECTION);
		glLoadIdentity ();
		ProjectionMatrix();

		glMatrixMode (GL_MODELVIEW);
		glLoadIdentity ();		

		cam_->LookAt();
		cam_->SwitchCamLight_On();
	}

	virtual void Display_End(){		
		FROG_Light::SwitchLight_Off();
	}

	virtual void Display(){		
		if(!displayFunc_)return;

		if(displayTexture_>0 && !IsActive){
			DisplayTexture();
		}else{						
			ClearBackground();
			Display_Begin();

			DisplayBkgGeom();		
			Display_Core();
			if(!IsActive)RecordTexture();

			Display_End();
		}
	}

	virtual void Display_Core(){
		if(frogObjects_ && frogObjects_->selectedObject_ && frogObjects_->selectedObject_DisplayFlag){
			if(frogObjects_->IsSelected_Geometry()){glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);}else{glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);}
			float color[4] = {1 - frogObjects_->selectedObject_->style_->color_[0],1 - frogObjects_->selectedObject_->style_->color_[1],1 - frogObjects_->selectedObject_->style_->color_[2],1};						
			frogObjects_->selectedObject_->display(true, color);
		}
		
		displayFunc_();		
	}

};


#endif

